/*
    CharityWorld: AllPortionDemandAgents.h
    Copyright (C) 2003  Macaulay Institute

    This file is part of CharityWorld, a simple agent-based model to
    demonstrate the effects of errors in floating point arithmetic on
    emergent outcomes.

    CharityWorld is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CharityWorld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/* 

This file contains the declaration for two classes:
PortionDemandAgent and ExtAvgPortionDemandAgent.
They only differ on the class they inherit from.
The implementation of the methods that they override 
is exactly the same for both classes.
(A dodgy way of doing multiple inheritance )

*/

#import "AllSimpleDemandAgents.h"

@class DoubleSimple;

/*

PortionDemandAgent.h

The PortionDemandAgent inherits from the SimpleDemandAgent.  The
amount they beg for is different, being a portion of the difference
between their wealth and their local average wealth.

*/

@interface PortionDemandAgent: SimpleDemandAgent {
}

-ask;

@end


/*

ExtAvgPortionDemandAgent.h

The ExtAvgPortionDemandAgent inherits from the
ExtAvgSimpleDemandAgent.  The amount they beg for is different, being
a portion of the difference between their wealth and their local
average wealth.

*/

@interface ExtAvgPortionDemandAgent: ExtAvgSimpleDemandAgent {
}

-ask;

@end

/*

GreedyPortionDemandAgent.h

The GreedyPortionDemandAgent inherits from the SimpleDemandAgent.  The
amount they beg for is different, being a portion of the difference
between their wealth and the average of their wealth and the selected
responder's wealth.

*/

@interface GreedyPortionDemandAgent: SimpleDemandAgent {
}

-ask;

@end
